-- BetterDefaulUI 4.9 by Andromerius (pongo2002@gmail.com) 2023

-- Create Ace3 Addon.
BDU = LibStub('AceAddon-3.0'):NewAddon('BetterDefaultUI', 'AceConsole-3.0', 'AceHook-3.0', 'AceEvent-3.0');

-- LibSharedMedia-3.0
LSM = LibStub('LibSharedMedia-3.0');

function BDU:OnInitialize()

    LSM:Register(LSM.MediaType.FONT, 'BetterDefaultUI Font', [[Interface\AddOns\BetterDefaultUI\media\font.ttf]]);
	
end

if BetterDefaultUIDBC == nil then
    BetterDefaultUIDBC = {
        xpbar = "enable",
		unit_frames = "enable",
		Loot = "enable",
		combat = "enable",
		castbar = "enable",
        Bags = {}
    }
end

if BetterDefaultUIDBC.unit_frames == nil then
    BetterDefaultUIDBC.unit_frames = "enable"
end
if BetterDefaultUIDBC.xpbar == nil then
    BetterDefaultUIDBC.xpbar = "enable"
end
if BetterDefaultUIDBC.Bags == nil then
    BetterDefaultUIDBC.Bags = {}
end
if BetterDefaultUIDBC.Loot == nil then
	BetterDefaultUIDBC.Loot = "enable"
end
if BetterDefaultUIDBC.castbar == nil then
	BetterDefaultUIDBC.castbar = "enable"
end
if BetterDefaultUIDBC.combat == nil then
	BetterDefaultUIDBC.combat = "enable"
end

-- Setup slash command
SLASH_BDU1 = '/bdu'


customXPBar = nil
actionxpbar = nil
actionnoxpbar = nil
setbars = nil

if WOW_PROJECT_ID == WOW_PROJECT_WRATH_CLASSIC then

		-- Resize MainMenuBar 
	MainMenuBar:SetWidth(512)
	MainMenuBarMaxLevelBar:SetWidth(512)

   -- Remove Gryphons and other stuff
    MainMenuBarLeftEndCap:Hide()
    MainMenuBarRightEndCap:Hide()
	MainMenuBarPageNumber:Hide()
	ActionBarUpButton:Hide()
	ActionBarDownButton:Hide()
	MainMenuBarTexture2:Hide()
	MainMenuBarTexture3:Hide()
	MainMenuMaxLevelBar0:Hide()
	MainMenuMaxLevelBar1:Hide()
	MainMenuMaxLevelBar2:Hide()
	MainMenuMaxLevelBar3:Hide()
	TargetFrameSpellBar.Border:Hide()
--	MainMenuBarMaxLevelBar:Hide()
	
	-- Clear extra XP/Rep bar textures
	MainMenuMaxLevelBar0:SetTexture(nil)
	MainMenuMaxLevelBar1:SetTexture(nil)
	MainMenuMaxLevelBar2:SetTexture(nil)
	MainMenuMaxLevelBar3:SetTexture(nil)

    -- Hide the textures of the MainMenuBarArtFrame
	MainMenuBarTexture0:Hide()
	MainMenuBarTexture1:Hide()

	-- Hide the textures of the default XP bar
	MainMenuBarTexture2:Hide()
	MainMenuBarTexture3:Hide()

	-- Move the default XP bar offscreen so we can hide it.
	MainMenuExpBar:ClearAllPoints()
	MainMenuExpBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMRIGHT", 10000, 0)

	-- Move the default reputation bar offscreen
	ReputationWatchBar:ClearAllPoints()
	ReputationWatchBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMRIGHT", 10000, 0)

function setbars()
    if InCombatLockdown() then
        return
    end 

    local _, playerClass = UnitClass("player")

local classActionBars = {
    ["WARLOCK"] = {"VehicleActionBarFrame", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["HUNTER"] = {"VehicleActionBarFrame", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["DEATHKNIGHT"] = {"VehicleActionBarFrame", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton", "RuneFrame", "StanceBarFrame"},
    ["PRIEST"] = {"VehicleActionBarFrame", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["SHAMAN"] = {"VehicleActionBarFrame", "StanceButton1", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton", "MultiCastActionBarFrame"},
    ["MAGE"] = {"VehicleActionBarFrame", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["ROGUE"] = {"VehicleActionBarFrame", "StanceButton1", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["WARRIOR"] = {"VehicleActionBarFrame", "StanceButton1", "StanceButton2", "StanceButton3", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["PALADIN"] = {"VehicleActionBarFrame", "StanceButton1", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["DRUID"] = {"VehicleActionBarFrame", "StanceButton1", "PossessBarFrame", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"}
}


    local actionBarPositions = {
        ["VehicleActionBarFrame"] = function()
            local anchorFrame
            if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPRIGHT", 0, 5}
        end,
		["MainMenuBarVehicleLeaveButton"] = function()
			local anchorFrame
			if  _G["RuneFrame"]:IsShown() then
				anchorFrame = _G["RuneFrame"]
			elseif _G["StanceButton1"]:IsShown() then
				anchorFrame = _G["StanceButton1"]
			elseif _G["StanceButton2"]:IsShown() then
				anchorFrame = _G["StanceButton2"]
			elseif _G["StanceButton3"]:IsShown() then
				anchorFrame = _G["StanceButton3"]
            elseif _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPRIGHT", 0, 5}
        end,
        ["StanceButton1"] = function()
            local anchorFrame
            if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 5}
        end,
      ["StanceButton2"] = function()
            local anchorFrame
			if _G["StanceButton1"]:IsShown() then
				anchorFrame = _G["StanceButton1"]
            end
            return {"LEFT", anchorFrame, "RIGHT", 5, 0}
        end,
       ["StanceButton3"] = function()
            local anchorFrame
			if _G["StanceButton2"]:IsShown() then
				anchorFrame = _G["StanceButton2"]
            end
            return {"LEFT", anchorFrame, "RIGHT", 5, 0}
        end,
		["PossessBarFrame"] = function()
			local anchorFrame
			if _G["StanceButton1"]:IsShown() then
				anchorFrame = _G["StanceButton1"]
			elseif _G["MultiBarBottomRight"]:IsShown() then
				anchorFrame = _G["MultiBarBottomRightButton1"]
			elseif _G["MultiBarBottomLeft"]:IsShown() then
				anchorFrame = _G["MultiBarBottomLeftButton1"]
			else
				anchorFrame = _G["ActionButton1"]
			end
			return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 5}
		end,
       ["PetActionBarFrame"] = function()
            local anchorFrame
			if _G["StanceButton1"]:IsShown() then
				anchorFrame = _G["StanceButton1"]
			elseif _G["RuneFrame"]:IsShown() then
				anchorFrame = _G["RuneFrame"]
			elseif _G["MultiCastActionBarFrame"]:IsShown() then
				anchorFrame = _G["MultiCastActionBarFrame"]
            elseif _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 10}
        end,
		["MultiCastActionBarFrame"] = function()
            local anchorFrame
            if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 5}
        end,
		["RuneFrame"] = function()
            local anchorFrame
            if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 5}
        end,
		["StanceBarFrame"] = function()
            local anchorFrame
            if _G["RuneFrame"]:IsShown() then
                anchorFrame = _G["RuneFrame"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 5}
        end
    }

    local bars = classActionBars[playerClass]
    if bars then
        for _, bar in ipairs(bars) do
            local frame = _G[bar]
            if frame then
--                C_Timer.After(3, function()
                    frame:ClearAllPoints()
                    local position = actionBarPositions[bar]()
                    if position then
                        if InCombatLockdown() then
                            return
                        end
                        frame:SetPoint(unpack(position))
                    end
--                end)
            end
        end
		end
end

elseif WOW_PROJECT_ID == WOW_PROJECT_CLASSIC then

		-- Resize MainMenuBar 
	MainMenuBar:SetWidth(512)
	MainMenuBarMaxLevelBar:SetWidth(512)
	
   -- Remove Gryphons and other stuff
    MainMenuBarLeftEndCap:Hide()
    MainMenuBarRightEndCap:Hide()
	MainMenuBarPageNumber:Hide()
	ActionBarUpButton:Hide()
	ActionBarDownButton:Hide()
	MainMenuBarTexture2:Hide()
	MainMenuBarTexture3:Hide()
	MainMenuMaxLevelBar0:Hide()
	MainMenuMaxLevelBar1:Hide()
	MainMenuMaxLevelBar2:Hide()
	MainMenuMaxLevelBar3:Hide()
	TargetFrameSpellBar.Border:Hide()
--	MainMenuBarMaxLevelBar:Hide()
	
		-- Resize MainMenuBar 
	MainMenuBar:SetWidth(512)
	MainMenuBarMaxLevelBar:SetWidth(512)
	
	-- Clear extra XP/Rep bar textures
	MainMenuMaxLevelBar0:SetTexture(nil)
	MainMenuMaxLevelBar1:SetTexture(nil)
	MainMenuMaxLevelBar2:SetTexture(nil)
	MainMenuMaxLevelBar3:SetTexture(nil)

    -- Hide the textures of the MainMenuBarArtFrame
	MainMenuBarTexture0:Hide()
	MainMenuBarTexture1:Hide()

	-- Hide the textures of the default XP bar
	MainMenuBarTexture2:Hide()
	MainMenuBarTexture3:Hide()

	-- Move the default XP bar offscreen so we can hide it.
	MainMenuExpBar:ClearAllPoints()
	MainMenuExpBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMRIGHT", 10000, 0)

	-- Move the default reputation bar offscreen
	ReputationWatchBar:ClearAllPoints()
	ReputationWatchBar:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMRIGHT", 10000, 0)

function setbars()
    if InCombatLockdown() then
        return
    end 

    local _, playerClass = UnitClass("player")

local classActionBars = {
    ["WARLOCK"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["HUNTER"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["PRIEST"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["SHAMAN"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["MAGE"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["ROGUE"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["WARRIOR"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["PALADIN"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"},
    ["DRUID"] = {"VehicleActionBarFrame", "StanceButton1", "PetActionBarFrame", "MainMenuBarVehicleLeaveButton"}
}


    local actionBarPositions = {
        ["VehicleActionBarFrame"] = function()
            local anchorFrame
            if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPRIGHT", 0, 5}
        end,
		["MainMenuBarVehicleLeaveButton"] = function()
			local anchorFrame
           if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPRIGHT", 0, 5}
        end,
        ["StanceButton1"] = function()
            local anchorFrame
            if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 5}
        end,
       ["PetActionBarFrame"] = function()
            local anchorFrame
            if _G["MultiBarBottomRight"]:IsShown() then
                anchorFrame = _G["MultiBarBottomRightButton1"]
            elseif _G["MultiBarBottomLeft"]:IsShown() then
                anchorFrame = _G["MultiBarBottomLeftButton1"]
            else
                anchorFrame = _G["ActionButton1"]
            end
            return {"BOTTOMLEFT", anchorFrame, "TOPLEFT", 0, 5}
        end
    }

    local desiredX = 0
    local desiredY = 5

    function totemposition()
        if playerClass == "SHAMAN" and (_G["MultiCastActionBarFrame"] or HasMultiCastActionBar) and not InCombatLockdown() then
            local TotemBar1 = _G["MultiCastActionBarFrame"]
            if TotemBar1 then
                local _, _, _, currentX, currentY = TotemBar1:GetPoint()
                if currentX ~= desiredX or currentY ~= desiredY then
                    TotemBar1:ClearAllPoints()
                    TotemBar1:SetPoint("BOTTOMLEFT", actionBarPositions["StanceButton1"]()[2], "TOPLEFT", desiredX, desiredY)
                end
            end
        end
    end

    if playerClass == "SHAMAN" then
        C_Timer.NewTicker(0.02, totemposition)
    end

    local bars = classActionBars[playerClass]
    if bars then
        for _, bar in ipairs(bars) do
            local frame = _G[bar]
            if frame then
                C_Timer.After(3, function()
                    frame:ClearAllPoints()
                    local position = actionBarPositions[bar]()
                    if position then
                        if InCombatLockdown() then
                            return
                        end
                        frame:SetPoint(unpack(position))
                    end
                    if bar == "MultiCastActionBarFrame" and not frame:IsShown() then
                        frame:Show()
                    end
                end)
            end
        end
	end

end

end

function xpbar()
-- Create a custom XP bar
customXPBar = CreateFrame("StatusBar", "CustomXPBar", MainMenuBar)

customXPBar:SetSize(495, 5) -- Match the size of the default XP bar
customXPBar:SetPoint("CENTER", UIParent, "BOTTOM", 0, 5) -- Adjust the position under the action bars

-- Create a texture for the earned XP portion
local xpBarTexture = customXPBar:CreateTexture(nil, "ARTWORK")
xpBarTexture:SetTexture("Interface\\TargetingFrame\\UI-StatusBar")
customXPBar:SetStatusBarTexture(xpBarTexture)
customXPBar:SetStatusBarColor(0, 0.4, 1) -- Color for the earned XP

-- Create a texture for the unearned XP portion
local xpBarBackground = customXPBar:CreateTexture(nil, "BACKGROUND")
xpBarBackground:SetTexture("Interface\\TargetingFrame\\UI-StatusBar")
xpBarBackground:SetAllPoints(customXPBar)
xpBarBackground:SetVertexColor(0.5, 0.5, 0.5)


-- Create separators
local numSegments = 10 -- Adjust the number of segments as desired
local segmentWidth = customXPBar:GetWidth() / numSegments
for i = 0, numSegments do
    local separator = customXPBar:CreateTexture(nil, "ARTWORK")
    separator:SetColorTexture(1, 1, 1, 1)
    separator:SetSize(1, customXPBar:GetHeight())
    separator:SetPoint("LEFT", customXPBar, "LEFT", i * segmentWidth, 0)
end
--[[
-- Create text to display current XP
local xpText1 = customXPBar:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
xpText1:SetPoint("BOTTOM", customXPBar, "TOPRIGHT", -45, 3)
xpText1:SetFont("Fonts\\ARIALN.TTF", 10, "nil")
xpText1:SetTextColor(1, 0, 0)

-- Create text separator
local xpTextSeparator = customXPBar:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
xpTextSeparator:SetPoint("LEFT", xpText1, "RIGHT", 0, 0)
xpTextSeparator:SetFont("Fonts\\ARIALN.TTF", 10, "nil")
xpTextSeparator:SetTextColor(1, 1, 1)

-- Create text to display max XP
local xpText2 = customXPBar:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
xpText2:SetPoint("LEFT", xpTextSeparator, "RIGHT", 0, 0)
xpText2:SetFont("Fonts\\ARIALN.TTF", 10, "nil")
xpText2:SetTextColor(0, 1, 0)
--]]

-- Get the player's level.
    local playerLevel = UnitLevel("player")

-- Get player class
    local _, playerClass = UnitClass("player")

function formatNumber(number)
    local number = number / 1000
    return string.format("%.1f", number)
end

local currentXP = UnitXP("player")
local maxXP = UnitXPMax("player")
customXPBar:SetMinMaxValues(0, maxXP)
customXPBar:SetValue(currentXP)
local nextLevel = playerLevel + 1
local percentRemaining = (1 - (currentXP / maxXP)) * 100

end

local UnitHealth = UnitHealth;
local UnitHealthMax = UnitHealthMax;
local UnitPower = UnitPower;
local UnitPowerMax = UnitPowerMax;
local UnitExists = UnitExists;
local InCombatLockdown = InCombatLockdown;

function change_unit_frames()

if WOW_PROJECT_ID == WOW_PROJECT_WRATH_CLASSIC then
	
-- if InCombatLockdown() then return end

function alt_color(r, g, b, a)
    return {
        r = r,
        g = g,
        b = b,
        a = a,
    };
end
function ClassColors(unit)
    local _, class = UnitClass(unit);

	-- Special for Shamans.
    if class == 'SHAMAN' then
        return alt_color(0.0, 0.44, 0.87, 1);
    end

    -- If we get the class, get the color.
    if (class and RAID_CLASS_COLORS[class]) then
        return RAID_CLASS_COLORS[class];
    end

    -- If we do not get the class, make it white.
    return alt_color(1, 1, 1, 1);
end

function ApplyClassColors(statusBar, unit)
    if ( UnitIsConnected(unit) and unit == statusBar.unit and UnitClass(unit) ) then
        local c = ClassColors(unit);
        statusBar:SetStatusBarColor(c.r, c.g, c.b );
    end
end

function PlayerClassColors(bar)
    if bar.unit == 'player' then
        ApplyClassColors(bar, bar.unit);
    end
end

function TargetClassColors(bar)
    if bar.unit == 'target' then
        ApplyClassColors(bar, bar.unit);
    end
end

local scale = 1.1

-- Change Texture
PlayerFrameTexture:SetTexture('Interface\\AddOns\\BetterDefaultUI\\media\\UI-TargetingFrame');
PlayerStatusTexture:SetTexture('Interface\\AddOns\\BetterDefaultUI\\media\\UI-Player-Status');

    -- Update Health Bar Size
    PlayerFrameHealthBar:SetWidth(120);
    PlayerFrameHealthBar:SetHeight(29);
    PlayerFrameHealthBar:SetPoint('TOPLEFT',106,-22);
    PlayerFrameHealthBarText:SetPoint('CENTER',50,6);
	PlayerFrameHealthBar:SetAlpha(1.0);
--	PlayerFrameBackground:SetHeight(29);

if not UnitIsDead("player") then
-- PlayerFrameBackground:SetTexture('Interface\\AddOns\\BetterDefaultUI\\media\\UI-BDU-Frame')
PlayerFrameBackground:SetVertexColor(0.25 * 0.8, 0.25 * 0.8, 0.25 * 0.8, 1)
PlayerFrameBackground:SetWidth(120);
PlayerFrameBackground:SetHeight(29);
	
-- Get the texture from TargetFrameNameBackground
local texturePath = TargetFrameNameBackground:GetTexture()

-- Set the texture of PlayerFrameBackground
PlayerFrameBackground:SetTexture(texturePath)

PlayerFrameBackground:SetVertexColor(0.25 * 0.8, 0.25 * 0.8, 0.25 * 0.8, 1)
PlayerFrameBackground:SetWidth(120);
PlayerFrameBackground:SetHeight(29);

-- Tint the texture red
-- PlayerFrameBackground:SetVertexColor(1, 0, 0, 1)
end

--if classColor then
--	PlayerFrameHealthBar:SetStatusBarColor(classColor.r, classColor.g, classColor.b)
	PlayerFrameHealthBar.lockColor = true;
--end

-- Apply Fonts and Colours
local font = LSM:Fetch('font', font);
local _, _, flags = PlayerFrameHealthBarTextLeft:GetFont();
local r, g, b, a = PlayerFrameHealthBarTextLeft:GetTextColor();
	
PlayerName:SetFont(font, 11, flags);

PlayerFrameHealthBarText:SetFont(font, 10, flags);
PlayerFrameHealthBarTextLeft:SetFont(font, 10, flags);
PlayerFrameHealthBarTextRight:SetFont(font, 10, flags);

PlayerFrameManaBarText:SetFont(font, 10, flags);
PlayerFrameManaBarTextLeft:SetFont(font, 10, flags);
PlayerFrameManaBarTextRight:SetFont(font, 10, flags);

PlayerName:SetTextColor(1, 1, 1);

PetName:SetFont(font, 11, flags);
PetName:SetTextColor(r, g, b, a);
PetFrameHealthBarTextLeft:SetFont(font, 10, flags);
PetFrameHealthBarTextRight:SetFont(font, 10, flags);
PetFrameManaBarTextLeft:SetFont(font, 10, flags);
PetFrameManaBarTextRight:SetFont(font, 10, flags);

point, relativeTo, relativePoint, xOfs, yOfs = PlayerLevelText:GetPoint();
local level = UnitLevel('player');

if(level < 80) then
    xOfs = -61.5;
end

PlayerLevelText:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);

PlayerLevelText:SetFont(font, 10, flags);
PlayerLevelText:SetTextColor(r, g, b, a);

-- Apply class colors to player health bar
PlayerClassColors(PlayerFrameHealthBar);

-- Adjust the Player health text
PlayerFrameHealthBarText:ClearAllPoints()
PlayerFrameHealthBarText:SetPoint("CENTER", PlayerFrameHealthBar, "CENTER", 0, -8)

PlayerFrameHealthBarTextLeft:ClearAllPoints()
PlayerFrameHealthBarTextLeft:SetPoint("LEFT", PlayerFrameHealthBar, "LEFT", 4, -8)

PlayerFrameHealthBarTextRight:ClearAllPoints()
PlayerFrameHealthBarTextRight:SetPoint("RIGHT", PlayerFrameHealthBar, "RIGHT", -2, -8)


--____________________________________________________________--
--____________________________________________________________--
--                                                            --

-- Style target unit frames.


    local unitClassification = UnitClassification(TargetFrame.unit);

    -- What texture do we need?
    local frameTexture;
    if ( unitClassification == 'worldboss' or unitClassification == 'elite' ) then
		frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame-Elite';
	elseif ( unitClassification == 'rareelite' ) then
		frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame-Rare-Elite';
	elseif ( unitClassification == 'rare' ) then
        frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame-Rare';
    else
        frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame';
	end

    -- Apply the texture.
    TargetFrame.borderTexture:SetTexture(frameTexture);

    -- Update Health Bar Size
    TargetFrame.healthbar:SetHeight(29);
    TargetFrame.healthbar:SetPoint('TOPLEFT',7,-22);

    TargetFrame.deadText:SetPoint('CENTER',-50,6);
    TargetFrame.Background:SetPoint('TOPLEFT',7,-22);
    TargetFrame.healthbar:SetWidth(120);
	TargetFrameNameBackground:SetHeight(29);
	TargetFrameNameBackground:SetVertexColor(0.25 * 0.8, 0.25 * 0.8, 0.25 * 0.8, 1)
    TargetFrameNameBackground:SetWidth(120);


if not UnitIsPlayer(TargetFrame.unit) then
    local reaction = UnitReaction(TargetFrame.unit, "player")
    local color

    if reaction and reaction <= 2 then
        color = { r = 1, g = 0, b = 0 } -- Hostile: Red
    elseif reaction and reaction <= 4 then
        color = { r = 1, g = 1, b = 0 } -- Neutral: Yellow
    else
        color = { r = 0, g = 1, b = 0 } -- Friendly: Green
    end

    TargetFrame.healthbar:SetStatusBarColor(color.r, color.g, color.b)
    TargetFrame.healthbar.lockColor = true
end



    TargetFrameTextureFrameName:SetFont(font, 11, flags);
	
        TargetFrameTextureFrame.HealthBarText:SetFont(font, 10, flags);
        TargetFrameTextureFrame.HealthBarTextLeft:SetFont(font, 10, flags);
        TargetFrameTextureFrame.HealthBarTextRight:SetFont(font, 10, flags);
        
        TargetFrameTextureFrame.ManaBarText:SetFont(font, 10, flags);
        TargetFrameTextureFrame.ManaBarTextLeft:SetFont(font, 10, flags);
        TargetFrameTextureFrame.ManaBarTextRight:SetFont(font, 10, flags);

    point, relativeTo, relativePoint, xOfs, yOfs = TargetFrameTextureFrameLevelText:GetPoint();
    local level = UnitLevel('target');

    xOfs = 64.5;

    TargetFrameTextureFrameLevelText:SetFont(font, 10, flags);
    TargetFrameTextureFrameLevelText:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);

    -- Flash texture for low ncp/players.
    if (unitClassification == 'minus') then
        TargetFrameFlash:SetTexture('Interface\\TargetingFrame\\UI-TargetingFrame-Flash');
        TargetFrameFlash:SetTexCoord(0, 0.9453125, 0, 0.181640625);
        TargetFrameFlash:SetWidth(242);
		TargetFrameFlash:SetHeight(93);
		TargetFrameFlash:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", -24, 0);
    end

    if ( TargetFrame.totFrame ) then
        TargetFrameToTTextureFrameName:SetFont(font, 11, flags);
    end

if UnitIsDead("target") then
TargetFrameHealthBar.TextString:Hide()
end

if UnitIsPlayer(TargetFrame.unit) then
TargetClassColors(TargetFrame.healthbar, TargetFrame.healthbar.unit);
end

-- Adjust the Target's health text
TargetFrameTextureFrame.HealthBarText:ClearAllPoints()
TargetFrameTextureFrame.HealthBarText:SetPoint("CENTER", TargetFrame.healthbar, "CENTER", 0, -8)

TargetFrameTextureFrame.HealthBarTextLeft:ClearAllPoints()
TargetFrameTextureFrame.HealthBarTextLeft:SetPoint("LEFT", TargetFrame.healthbar, "LEFT", 0, -8)

TargetFrameTextureFrame.HealthBarTextRight:ClearAllPoints()
TargetFrameTextureFrame.HealthBarTextRight:SetPoint("RIGHT", TargetFrame.healthbar, "RIGHT", -4, -8)

elseif WOW_PROJECT_ID == WOW_PROJECT_CLASSIC then

-- if InCombatLockdown() then return end
MainMenuBarPerformanceBar:Hide()


function alt_color(r, g, b, a)
    return {
        r = r,
        g = g,
        b = b,
        a = a,
    };
end
function ClassColors(unit)
    local _, class = UnitClass(unit);

	-- Special for Shamans.
    if class == 'SHAMAN' then
        return alt_color(0.0, 0.44, 0.87, 1);
    end

    -- If we get the class, get the color.
    if (class and RAID_CLASS_COLORS[class]) then
        return RAID_CLASS_COLORS[class];
    end

    -- If we do not get the class, make it white.
    return alt_color(1, 1, 1, 1);
end

function ApplyClassColors(statusBar, unit)
    if ( UnitIsConnected(unit) and unit == statusBar.unit and UnitClass(unit) ) then
        local c = ClassColors(unit);
        statusBar:SetStatusBarColor(c.r, c.g, c.b );
    end
end

function PlayerClassColors(bar)
    if bar.unit == 'player' then
        ApplyClassColors(bar, bar.unit);
    end
end

function TargetClassColors(bar)
    if bar.unit == 'target' then
        ApplyClassColors(bar, bar.unit);
    end
end

local scale = 1.1

-- Change Texture
PlayerFrameTexture:SetTexture('Interface\\AddOns\\BetterDefaultUI\\media\\UI-TargetingFrame');
PlayerStatusTexture:SetTexture('Interface\\AddOns\\BetterDefaultUI\\media\\UI-Player-Status');

    -- Update Health Bar Size
    PlayerFrameHealthBar:SetWidth(120);
    PlayerFrameHealthBar:SetHeight(29);
    PlayerFrameHealthBar:SetPoint('TOPLEFT',106,-22);
    PlayerFrameHealthBarText:SetPoint('CENTER',50,6);
	PlayerFrameHealthBar:SetAlpha(1.0);
--	PlayerFrameBackground:SetHeight(29);

if not UnitIsDead("player") then
-- PlayerFrameBackground:SetTexture('Interface\\AddOns\\BetterDefaultUI\\media\\UI-BDU-Frame')
PlayerFrameBackground:SetVertexColor(0.25 * 0.8, 0.25 * 0.8, 0.25 * 0.8, 1)
PlayerFrameBackground:SetWidth(120);
PlayerFrameBackground:SetHeight(29);
	
-- Get the texture from TargetFrameNameBackground
local texturePath = TargetFrameNameBackground:GetTexture()

-- Set the texture of PlayerFrameBackground
PlayerFrameBackground:SetTexture(texturePath)

PlayerFrameBackground:SetVertexColor(0.25 * 0.8, 0.25 * 0.8, 0.25 * 0.8, 1)
PlayerFrameBackground:SetWidth(120);
PlayerFrameBackground:SetHeight(29);

-- Tint the texture red
-- PlayerFrameBackground:SetVertexColor(1, 0, 0, 1)
end

--if classColor then
--	PlayerFrameHealthBar:SetStatusBarColor(classColor.r, classColor.g, classColor.b)
	PlayerFrameHealthBar.lockColor = true;
--end
-- Apply Fonts and Colours
local font = LSM:Fetch('font', font);
local _, _, flags = PlayerFrameHealthBarTextLeft:GetFont();
local r, g, b, a = PlayerFrameHealthBarTextLeft:GetTextColor();
	
PlayerName:SetFont(font, 11, flags);

PlayerFrameHealthBarText:SetFont(font, 10, flags);
PlayerFrameHealthBarTextLeft:SetFont(font, 10, flags);
PlayerFrameHealthBarTextRight:SetFont(font, 10, flags);

PlayerFrameManaBarText:SetFont(font, 10, flags);
PlayerFrameManaBarTextLeft:SetFont(font, 10, flags);
PlayerFrameManaBarTextRight:SetFont(font, 10, flags);

PlayerName:SetTextColor(1, 1, 1);

PetName:SetFont(font, 11, flags);
PetName:SetTextColor(r, g, b, a);
PetFrameHealthBarTextLeft:SetFont(font, 10, flags);
PetFrameHealthBarTextRight:SetFont(font, 10, flags);
PetFrameManaBarTextLeft:SetFont(font, 10, flags);
PetFrameManaBarTextRight:SetFont(font, 10, flags);

point, relativeTo, relativePoint, xOfs, yOfs = PlayerLevelText:GetPoint();
local level = UnitLevel('player');

if(level < 60) then
    xOfs = -61.5;
end

PlayerLevelText:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);

PlayerLevelText:SetFont(font, 10, flags);
PlayerLevelText:SetTextColor(r, g, b, a);

-- Apply class colors to player health bar
PlayerClassColors(PlayerFrameHealthBar);

-- Adjust the Player health text
PlayerFrameHealthBarText:ClearAllPoints()
PlayerFrameHealthBarText:SetPoint("CENTER", PlayerFrameHealthBar, "CENTER", 0, -8)

PlayerFrameHealthBarTextLeft:ClearAllPoints()
PlayerFrameHealthBarTextLeft:SetPoint("LEFT", PlayerFrameHealthBar, "LEFT", 4, -8)

PlayerFrameHealthBarTextRight:ClearAllPoints()
PlayerFrameHealthBarTextRight:SetPoint("RIGHT", PlayerFrameHealthBar, "RIGHT", -2, -8)


--____________________________________________________________--
--____________________________________________________________--
--                                                            --

-- Style target unit frames.

    local unitClassification = UnitClassification(TargetFrame.unit);

    -- What texture do we need?
    local frameTexture;
    if ( unitClassification == 'worldboss' or unitClassification == 'elite' ) then
		frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame-Elite';
	elseif ( unitClassification == 'rareelite' ) then
		frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame-Rare-Elite';
	elseif ( unitClassification == 'rare' ) then
        frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame-Rare';
    else
        frameTexture = 'Interface\\Addons\\BetterDefaultUI\\media\\UI-TargetingFrame';
	end

    -- Apply the texture.
    TargetFrame.borderTexture:SetTexture(frameTexture);

    -- Update Health Bar Size
    TargetFrame.healthbar:SetHeight(29);
    TargetFrame.healthbar:SetPoint('TOPLEFT',7,-22);

    TargetFrame.deadText:SetPoint('CENTER',-50,6);
    TargetFrame.Background:SetPoint('TOPLEFT',7,-22);
    TargetFrame.healthbar:SetWidth(120);
	TargetFrameNameBackground:SetHeight(29);
	TargetFrameNameBackground:SetVertexColor(0.25 * 0.8, 0.25 * 0.8, 0.25 * 0.8, 1)
    TargetFrameNameBackground:SetWidth(120);

if UnitIsDead("target") then
TargetFrameHealthBar.TextString:Hide()
end
if not UnitIsPlayer(TargetFrame.unit) then
    local reaction = UnitReaction(TargetFrame.unit, "player")
    local color

    if reaction and reaction <= 2 then
        color = { r = 1, g = 0, b = 0 } -- Hostile: Red
    elseif reaction and reaction <= 4 then
        color = { r = 1, g = 1, b = 0 } -- Neutral: Yellow
    else
        color = { r = 0, g = 1, b = 0 } -- Friendly: Green
    end

    TargetFrame.healthbar:SetStatusBarColor(color.r, color.g, color.b)
    TargetFrame.healthbar.lockColor = true
end

    point, relativeTo, relativePoint, xOfs, yOfs = TargetFrameTextureFrameLevelText:GetPoint();
    local level = UnitLevel('target');

    xOfs = 64.5;

    TargetFrameTextureFrameLevelText:SetFont(font, 10, flags);
    TargetFrameTextureFrameLevelText:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);

    -- Flash texture for low ncp/players.
    if (unitClassification == 'minus') then
        TargetFrameFlash:SetTexture('Interface\\TargetingFrame\\UI-TargetingFrame-Flash');
        TargetFrameFlash:SetTexCoord(0, 0.9453125, 0, 0.181640625);
        TargetFrameFlash:SetWidth(242);
		TargetFrameFlash:SetHeight(93);
		TargetFrameFlash:SetPoint("TOPLEFT", TargetFrame, "TOPLEFT", -24, 0);
    end

    if ( TargetFrame.totFrame ) then
        TargetFrameToTTextureFrameName:SetFont(font, 11, flags);
    end

if UnitIsPlayer(TargetFrame.unit) then
TargetClassColors(TargetFrame.healthbar, TargetFrame.healthbar.unit);
end

-- Show status text
if not TargetFrameHealthBar.TextString then
    TargetFrameHealthBar.TextString = TargetFrameHealthBar:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
    TargetFrameHealthBar.TextString:SetFontObject(SystemFont_Small)
    TargetFrameHealthBar.TextString:SetPoint("CENTER", TargetFrameHealthBar, "CENTER", 0, -9)
end

if not TargetFrameManaBar.TextString then
    TargetFrameManaBar.TextString = TargetFrameManaBar:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
    TargetFrameManaBar.TextString:SetFontObject(SystemFont_Small)
    TargetFrameManaBar.TextString:SetPoint("CENTER", TargetFrameManaBar, "CENTER", 0, 0)
end

-- Update status text
local function UpdateTargetStatusText()
    local healthText = UnitHealth("target").."    /    "..UnitHealthMax("target")
    TargetFrameHealthBar.TextString:SetText(healthText)

    local manaText = ""
    if UnitIsPlayer("target") then
        local _, class = UnitClass("target")
        local powerType = UnitPowerType("target")
        if class and powerType and class ~= "PET" then
            local powerText = UnitPower("target", powerType)
            local powerMaxText = UnitPowerMax("target", powerType)
            manaText = powerText.."    /    "..powerMaxText
        end
    end
    TargetFrameManaBar.TextString:SetText(manaText)
	TargetFrameManaBar.TextString:SetFont(font, 9, flags);
end

hooksecurefunc("TargetFrame_CheckFaction", UpdateTargetStatusText)
-- hooksecurefunc("TargetFrame_OnShow", UpdateTargetStatusText)
end

end

function castbar()

-- Set the size of the CastingBarFrame
local width = 300  -- value to change the length of the casting bar
local height = 15  -- value to change the thickness of the casting bar
	CastingBarFrame:SetSize(width, height)
	CastingBarFrame:SetStatusBarTexture("Interface\\Buttons\\WHITE8X8")
	CastingBarFrame:SetStatusBarColor(0, 0, 0)
	CastingBarFrame.Border:Hide()
-- Set the position as before
local yOffsetCasting = 200
CastingBarFrame:ClearAllPoints()
CastingBarFrame:SetPoint("BOTTOM", UIParent, "BOTTOM", 0, yOffsetCasting)

end

-- Create a frame to run our code when the game finishes loading
local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGIN")
frame:RegisterEvent("PLAYER_REGEN_ENABLED")
frame:RegisterEvent("PLAYER_REGEN_DISABLED")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("UNIT_ENTERED_VEHICLE")
frame:RegisterEvent("UNIT_EXITED_VEHICLE")
frame:RegisterEvent("PLAYER_CONTROL_LOST")
frame:RegisterEvent("PLAYER_CONTROL_GAINED")
frame:RegisterEvent("PLAYER_LEVEL_UP")
frame:RegisterEvent("PLAYER_XP_UPDATE")
frame:RegisterEvent("UNIT_AURA")
frame:RegisterEvent("LOOT_CLOSED")
frame:RegisterEvent("BAG_UPDATE")
frame:RegisterEvent("MERCHANT_CLOSED")
frame:RegisterUnitEvent("UNIT_HEALTH", "target")
frame:RegisterUnitEvent("UNIT_HEALTH", "player")
frame:RegisterUnitEvent("UNIT_POWER_UPDATE", "player")
frame:RegisterUnitEvent("UNIT_POWER_UPDATE", "target")
frame:RegisterEvent("PLAYER_TARGET_CHANGED")
frame:RegisterUnitEvent("UNIT_MAXHEALTH", "target")
frame:RegisterUnitEvent("UNIT_MAXHEALTH", "player")
frame:RegisterEvent("ACTIONBAR_SHOWGRID")
frame:RegisterEvent("ACTIONBAR_HIDEGRID")
frame:RegisterEvent("UNIT_PET")
frame:RegisterUnitEvent("UNIT_EXITED_VEHICLE", "player")
frame:RegisterEvent("PET_BAR_UPDATE")

local startTime

frame:SetScript("OnEvent", function(self, event, unit, ...)
-- print("Event fired: " .. event)

if BetterDefaultUIDBC.unit_frames == nil then
    BetterDefaultUIDBC.unit_frames = "enable"
end
if BetterDefaultUIDBC.xpbar == nil then
    BetterDefaultUIDBC.xpbar = "enable"
end
if BetterDefaultUIDBC.Loot == nil then
    BetterDefaultUIDBC.Loot = "enable"
end
if BetterDefaultUIDBC.Bags == nil then
    BetterDefaultUIDBC.Bags = {}
end

if BetterDefaultUIDBC.castbar == nil then
    BetterDefaultUIDBC.castbar = "enable"
end

if BetterDefaultUIDBC.combat == nil then
    BetterDefaultUIDBC.combat = "enable"
end

    if event == "PLAYER_LOGIN" then
        print("|cFFFF0000BetterDefaultUI: ADDON LOADED! Please report any bugs.|r")
        print("|cFF88AAFFBetterDefaultUI: XP bar off/on: /bdu xpbar disable/enable.|r")
		print("|cFF88AAFFBetterDefaultUI: Unitframes off/on: /bdu unitframes disable/enable.|r")
		print("|cFF88AAFFBetterDefaultUI: Loot messages off/on: /bdu loot disable/enable.|r")
		print("|cFF88AAFFBetterDefaultUI: Castbar off/on: /bdu castbar disable/enable.|r")
		print("|cFF88AAFFBetterDefaultUI: Combat timer off/on: /bdu combat disable/enable.|r")
		print("|cFF88AAFFBetterDefaultUI: Type /reload in chat after changing options.|r")
    end

if WOW_PROJECT_ID == WOW_PROJECT_WRATH_CLASSIC then
MAX_PLAYER_LEVEL = 80
else
MAX_PLAYER_LEVEL = 60
end
	
if not IsAddOnLoaded("Bagnon") then
    local function OpenAllBagsHook()
        if not IsBagOpen(0) and not IsBagOpen(1) and not IsBagOpen(2) and not IsBagOpen(3) and not IsBagOpen(4) then
            OpenAllBags()
        else
            CloseAllBags()
        end
    end
    MainMenuBarBackpackButton:HookScript("OnClick", OpenAllBagsHook)
end


    -- If the unit is the target and the target has a class color, change the health bar to that color
    if unit == "target" and targetclassColor then
        TargetFrame.healthbar:SetStatusBarColor(targetclassColor.r, targetclassColor.g, targetclassColor.b)
    end

local function combat_timer()
-- Combat start and end msg and timer
    if event == "PLAYER_REGEN_DISABLED" then
        startTime = GetTime()
        print("Combat started!")
		end
	if event == "PLAYER_REGEN_ENABLED" and startTime then
        local endTime = GetTime()
        local elapsedTime = endTime - startTime

        startTime = nil -- Reset the start time for the next combat

        local minutes = math.floor(elapsedTime / 60)
        local seconds = math.floor(elapsedTime % 60)

        local timeMessage

        if minutes > 0 then
            timeMessage = string.format("Combat ended after %d minutes and %d seconds.", minutes, seconds)
        else
            timeMessage = string.format("Combat ended after %d seconds.", seconds)
        end

        print(timeMessage)
    end
end

if WOW_PROJECT_ID == WOW_PROJECT_WRATH_CLASSIC then
	-- Move Micro Menu and Bags
	CharacterMicroButton:ClearAllPoints()
	CharacterMicroButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -200, 0)
--	CharacterMicroButton:SetScale(0.5)
	
	MainMenuBarBackpackButton:ClearAllPoints()
	MainMenuBarBackpackButton:SetPoint("BOTTOMRIGHT", CharacterMicroButton, "TOPRIGHT", 200, -18)
--	MainMenuBarBackpackButton:SetScale(0.5)

MainMenuMaxLevelBar0:Hide()
MainMenuMaxLevelBar1:Hide()
MainMenuBarTexture0:Hide()
MainMenuBarTexture1:Hide()

else

-- Move Micro Menu latency button and Bags
CharacterMicroButton:ClearAllPoints()
CharacterMicroButton:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -180, 0)

MainMenuBarBackpackButton:ClearAllPoints()
MainMenuBarBackpackButton:SetPoint("BOTTOM", HelpMicroButton, "TOP", -5, -18)

MainMenuBarPerformanceBarFrame:Hide()

end

-- Set the desired size
local bagSize = 37

-- Resize the extra bag slots
CharacterBag0Slot:SetSize(bagSize, bagSize)
CharacterBag1Slot:SetSize(bagSize, bagSize)
CharacterBag2Slot:SetSize(bagSize, bagSize)
CharacterBag3Slot:SetSize(bagSize, bagSize)

    -- Hide individual bag buttons, leaving only the backpack button visible
 --   for i = 0, 4 do
 --       local bag = _G["CharacterBag"..i.."Slot"]
 --       if bag then
 --           bag:Hide()
 --       end
 --   end

function actionxpbar()
    if InCombatLockdown() then
        return
    end


   -- Detach Action Bars and stack them
    -- We will use the default action bar as our reference for position
    local yOffset = 5  -- This is the vertical distance between each bar
	
    for i = 1, 12 do
        local button1 = _G["ActionButton"..i]
        local button2 = _G["MultiBarBottomLeftButton"..i]
        local button3 = _G["MultiBarBottomRightButton"..i]
        if i == 1 then
			button1:ClearAllPoints()
			button1:SetPoint("BOTTOMLEFT", customXPBar, "TOPLEFT", 0, yOffset)
            button2:ClearAllPoints()
            button2:SetPoint("BOTTOM", button1, "TOP", 0, yOffset)
            button3:ClearAllPoints()
            button3:SetPoint("BOTTOM", button2, "TOP", 0, yOffset)
        else
            local previousButton2 = _G["MultiBarBottomLeftButton"..i-1]
            local previousButton3 = _G["MultiBarBottomRightButton"..i-1]
            button2:ClearAllPoints()
            button2:SetPoint("LEFT", previousButton2, "RIGHT", 6, 0)
            button3:ClearAllPoints()
            button3:SetPoint("LEFT", previousButton3, "RIGHT", 6, 0)
        end
    end
end

function actionnoxpbar()
    if InCombatLockdown() then
        return
    end

   -- Detach Action Bars and stack them
    -- We will use the default action bar as our reference for position
    local yOffset = 5  -- This is the vertical distance between each bar
    for i = 1, 12 do
        local button1 = _G["ActionButton"..i]
        local button2 = _G["MultiBarBottomLeftButton"..i]
        local button3 = _G["MultiBarBottomRightButton"..i]
        if i == 1 then
            button2:ClearAllPoints()
            button2:SetPoint("BOTTOM", button1, "TOP", 0, yOffset)
            button3:ClearAllPoints()
            button3:SetPoint("BOTTOM", button2, "TOP", 0, yOffset)
        else
            local previousButton2 = _G["MultiBarBottomLeftButton"..i-1]
            local previousButton3 = _G["MultiBarBottomRightButton"..i-1]
            button2:ClearAllPoints()
            button2:SetPoint("LEFT", previousButton2, "RIGHT", 6, 0)
            button3:ClearAllPoints()
            button3:SetPoint("LEFT", previousButton3, "RIGHT", 6, 0)
        end
    end
end

if event == "PLAYER_LOGIN" then

-- UNDRESS
-- Add undress button to dressup model window.
if not IsAddOnLoaded("Undressed") then

-- Create a separate frame to contain the button
local buttonFrame = CreateFrame("Frame", "UndressedButtonFrame", DressUpFrame)
buttonFrame:SetAllPoints(DressUpFrame)

-- Create the button within the separate frame
Undressed = CreateFrame("Button", "UndressedButton", buttonFrame, "UIPanelButtonTemplate")
Undressed:SetPoint("BOTTOMRIGHT", DressUpFrameResetButton, "BOTTOMLEFT", 0, 0)
Undressed:SetSize(60, 22)
Undressed:SetText("Undress")
Undressed:Raise()

Undressed:SetScript("OnClick", function(self)
    for i, child in ipairs({DressUpFrame:GetChildren()}) do
        if child:GetObjectType() == "DressUpModel" then
            child:Undress()
            break
        end
    end
end)
end

end

local playerLevel = UnitLevel("player")

if (event == "PLAYER_REGEN_DISABLED" or event == "PLAYER_REGEN_ENABLED") and BetterDefaultUIDBC.combat == "enable" then
combat_timer()
end
		
if event == "PLAYER_LOGIN" and BetterDefaultUIDBC.xpbar == "enable" and playerLevel < MAX_PLAYER_LEVEL then
C_Timer.After(1, function()
xpbar()
actionxpbar()
setbars()
end)
C_Timer.NewTicker(0.1, setbars)
end

if event == "PLAYER_LOGIN" and (playerLevel == MAX_PLAYER_LEVEL or BetterDefaultUIDBC.xpbar == "disable") then
C_Timer.After(1, function()
actionnoxpbar()
setbars()
end)
C_Timer.NewTicker(0.1, setbars)
end

if (event == "PLAYER_LEVEL_UP" or event == "PLAYER_XP_UPDATE") and BetterDefaultUIDBC.xpbar == "enable" and playerLevel < MAX_PLAYER_LEVEL then

        -- Retrieve the player's current and max XP, update the xp bar
        local currentXP = UnitXP("player")
        local maxXP = UnitXPMax("player")
        customXPBar:SetMinMaxValues(0, maxXP)
        customXPBar:SetValue(currentXP)
end

function SlashCmdList.BDU(msg, editbox)
    local command, rest = msg:match("^(%S*)%s*(.-)$");

    if command:lower() == "xpbar" then
        if rest:lower() == "enable" then
            print("|cFFFF0000BetterDefaultUI: XP BAR enabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.xpbar = "enable"

        elseif rest:lower() == "disable" then
			print("|cFFFF0000BetterDefaultUI: XP BAR disabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.xpbar = "disable"
        end
    end
	
	if command:lower() == "unitframes" then
		if rest:lower() == "enable" then
			print("|cFFFF0000BetterDefaultUI: UnitFrames modifications enabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.unit_frames = "enable"
			
		elseif rest:lower() == "disable" then
			print("|cFFFF0000BetterDefaultUI: UnitFrames modifications disabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.unit_frames = "disable"
		end
	end
	
	if command:lower() == "loot" then
		if rest:lower() == "enable" then
			print("|cFFFF0000BetterDefaultUI: Loot messages enabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.Loot = "enable"
			
		elseif rest:lower() == "disable" then
			print("|cFFFF0000BetterDefaultUI: Loot messages disabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.Loot = "disable"
end
end

	if command:lower() == "castbar" then
		if rest:lower() == "enable" then
			print("|cFFFF0000BetterDefaultUI: Custom castbar enabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.castbar = "enable"
			
		elseif rest:lower() == "disable" then
			print("|cFFFF0000BetterDefaultUI: Custom castbar disabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.castbar = "disable"
end
end

	if command:lower() == "combat" then
		if rest:lower() == "enable" then
			print("|cFFFF0000BetterDefaultUI: Combat timer enabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.combat = "enable"
			
		elseif rest:lower() == "disable" then
			print("|cFFFF0000BetterDefaultUI: Combat timer disabled, please type /reload and press enter in your chat!|r")
			BetterDefaultUIDBC.combat = "disable"
end
end
end

if BetterDefaultUIDBC.Loot == "enable" then

local function scanPlayerBags(printOutput)


    local previousCounts = {}  -- Store previous item counts from saved variables
    local currentCounts = {}   -- Store current item counts from the bag scan

    -- Copy the item counts from saved variables to previousCounts
    if BetterDefaultUIDBC.Bags then
        for itemID, count in pairs(BetterDefaultUIDBC.Bags) do
            previousCounts[itemID] = count
        end
    end

    -- Scan the bags and update currentCounts
    local itemCounts = {}
    for bag = 0, 4 do
        local numSlots = C_Container.GetContainerNumSlots(bag)
        for slot = 1, numSlots do
            local containerInfo = C_Container.GetContainerItemInfo(bag, slot)
            if containerInfo then
                local itemID = containerInfo.itemID
                local count = containerInfo.stackCount
                if not itemCounts[itemID] then itemCounts[itemID] = 0 end
                itemCounts[itemID] = itemCounts[itemID] + count
            end
        end
    end

    -- Update currentCounts with the item counts from the bag scan
    for itemID, count in pairs(itemCounts) do
        currentCounts[itemID] = count
    end

    -- Compare currentCounts with previousCounts and output loot messages
    for itemID, currentCount in pairs(currentCounts) do
        local previousCount = previousCounts[itemID]
        local change = currentCount - (previousCount or 0)
        if change > 0 and printOutput then
            local itemName, itemLink = GetItemInfo(itemID)
            print("|cFFFFFF00You looted ".. itemLink .." x" ..change ..", you now have ".. currentCount .." in your bags.")
        end
    end

    -- Update the saved variables with the new item counts
    BetterDefaultUIDBC.Bags = currentCounts
end

local function delayedScanPlayerBags()
    C_Timer.After(1, function()
        scanPlayerBags(true)  -- Scan the bags and print loot messages
    end)
end

    if event == "LOOT_CLOSED" then
        delayedScanPlayerBags()  -- Delayed bag scan after loot is closed
    elseif event == "PLAYER_ENTERING_WORLD" then
        scanPlayerBags(false)  -- Initial bag scan without printing loot messages
    end
	
	    if event == "MERCHANT_CLOSED" then
        scanPlayerBags(false)  -- Bag scan after the player closes the vendor window
    end

    if event == "LOOT_CLOSED" then
        delayedScanPlayerBags()  -- Delayed bag scan after loot is closed
    elseif event == "PLAYER_ENTERING_WORLD" then
        scanPlayerBags(false)   -- Initial bag scan without printing loot messages
    elseif event == "MERCHANT_CLOSED" then
        scanPlayerBags(false)   -- Bag scan after the player closes the vendor window
    end
-- end)
end

-- Event firing for custom unit frames.
if ( IsInInstance() or event == "PLAYER_LEVEL_UP" or event == "PLAYER_XP_UPDATE" or event == "UNIT_MAXHEALTH" or event == "PLAYER_TARGET_CHANGED" or event == "PLAYER_REGEN_ENABLED" or event == "UNIT_HEALTH" or event == "PLAYER_LOGIN" or event == "PLAYER_ENTERING_WORLD" or event == "UNIT_ENTERED_VEHICLE" or event == "UNIT_EXITED_VEHICLE" or event == "PLAYER_CONTROL_GAINED" or event) and BetterDefaultUIDBC.unit_frames == "enable" then
change_unit_frames()
if BetterDefaultUIDBC.castbar == "enable" then
castbar()
end
end

end)
